########################################################################
#
#	     ====================================================
#	     Make descriptor file for NLSL and related programs
#	     ====================================================
#
#  VERSION FOR RUNNING VS FORTRAN UNDER AIX
#
########################################################################
#

.SUFFIXES:
.SUFFIXES: .f .inc .obj .c 
.PRECIOUS: .f .inc .h .c

F77 = f90
# FFLAGS = -c -O -qspnans -qflttrap
#FFLAGS = -c -O
FFLAGS = /compile_only /names:uppercase
#CFLAGS = -c -O
#FLINK = f90
LIBS = dfor.lib

#	
#-----------------------------------------------------------------------
#			Definitions
#-----------------------------------------------------------------------
#

SPCI = nlsdim.inc eprprm.inc expdat.inc parcom.inc tridag.inc basis.inc pidef.inc
BASI = nlsdim.inc eprprm.inc parcom.inc basis.inc stdio.inc
LETI = nlsdim.inc eprprm.inc expdat.inc prmeqv.inc parcom.inc lpnam.inc
NLSI = nlsdim.inc eprprm.inc expdat.inc lmcom.inc stdio.inc parcom.inc
PRMI = nlsdim.inc eprprm.inc lmcom.inc parcom.inc lpnam.inc
FUNI = nlsdim.inc eprprm.inc expdat.inc tridag.inc parcom.inc iterat.inc
FNI2 = basis.inc pidef.inc stdio.inc prmeqv.inc mspctr.inc ftwork.inc 
FITI = nlsnam.inc eprmat.inc errmsg.inc mspctr.inc iterat.inc
MATI = nlsdim.inc eprprm.inc eprmat.inc rndoff.inc
CHKI = maxl.inc nlsdim.inc eprprm.inc rndoff.inc prmeqv.inc errmsg.inc
DATI = nlsdim.inc expdat.inc mspctr.inc nlsnam.inc stdio.inc parcom.inc 
SCLI = nlsdim.inc expdat.inc lmcom.inc parcom.inc mspctr.inc iterat.inc 
CGO  = cscg.obj zaypx.obj cgltri.obj zdotu.obj zaxpy.obj scmvm.obj tdsqz.obj tdchek.obj
EPO1 = momdls.obj eprls.obj matrll.obj cd2km.obj anxlk.obj w3j.obj stvect.obj cfs.obj $(CGO)
EPO2 = pstvec.obj pmatrl.obj ccrints.obj fzs.obj bessel.obj plgndr.obj ipar.obj
NLSB = lbasix.obj setmts.obj 
NLSC1 = datac.obj fitc.obj letc.obj addprm.obj rmvprm.obj statc.obj tensym.obj writec.obj
NLSC2 = convtc.obj helpc.obj srchc.obj setprm.obj assgnc.obj basisc.obj shiftc.obj scalec.obj
NLSC3 = covrpt.obj stats.obj confc.obj series.obj sitec.obj varyc.obj fixc.obj parc.obj
NLSC = $(NLSC1) $(NLSC2) $(NLSC3)
NLSD = setnm.obj getdat.obj genio.obj fmomnt.obj correl.obj ftfuns.obj gconvl.obj
NLSH = sshift.obj sscale.obj lgrint.obj mnbrak.obj brent.obj l1pfun.obj qrutil.obj writr.obj
NLSF = fitl.obj lfun.obj lcheck.obj setspc.obj $(NLSH) $(EPO1) $(EPO2) ordrpr.obj
NLSL = lmnls.obj enorm.obj dpmpar.obj qrfac.obj lmpar.obj qrsolv.obj covar.obj
NLSN = dchex.obj daxpy.obj dcopy.obj ddot.obj drotg.obj
#NLSP = pltx.obj 
NLSP = mimic.obj
# NLSP = pltd.obj
#NLSS = strutl.obj lprmpt.obj catch.obj ipfind.obj nlstxt.obj dtime.obj 
NLSS = strutl.obj lprmpt.obj ipfind.obj nlstxt.obj
#
SRLSI = srsset.inc srsdat.inc srsflg.inc srsind.inc srssto.inc
#SRLSO = pmatrl.obj srls.obj pstvec.obj fzs.obj
SRLSO = srls.obj lbasis.obj caldlm.obj
#
NLSO = nlsl.obj $(NLSC) $(NLSS) $(NLSD) $(NLSF) $(NLSL) $(NLSP) $(NLSN) $(NLSB)\
       $(NLSW) $(SRLSO)
#
#-----------------------------------------------------------------------
#		Object files
#-----------------------------------------------------------------------

addprm.obj	: addprm.f nlsdim.inc eprprm.inc expdat.inc parcom.inc lpnam.inc lmcom.inc stdio.inc rndoff.inc prmeqv.inc
assgnc.obj	: assgnc.f $(BASI)
bessel.obj	: bessel.f rndoff.inc
basisc.obj	: basisc.f $(BASI)
caldlm.obj	: caldlm.f rndoff.inc pidef.inc
cd2km.obj	: cd2km.f
cgltri.obj	: cgltri.f nlsdim.inc rndoff.inc
confc.obj	: confc.f iterat.inc stdio.inc
convlv.obj	: convlv.f nlsdim.inc
convtc.obj	: convtc.f nlsdim.inc eprprm.inc stdio.inc lpnam.inc parcom.inc
covrpt.obj	: covrpt.f nlsdim.inc eprprm.inc expdat.inc parcom.inc\
		  lmcom.inc lpnam.inc mspctr.inc iterat.inc rndoff.inc\
		  stdio.inc
cscg.obj	: cscg.f nlsdim.inc eprmat.inc rndoff.inc 
cslnzs.obj 	: cslnzs.f nlsdim.inc eprmat.inc
datac.obj	: datac.f $(DATI) mspctr.inc lmcom.inc rndoff.inc
eprls.obj	: eprls.f $(MATI) ftwork.inc tridag.inc pidef.inc
fitc.obj	: fitc.f nlsdim.inc lmcom.inc parcom.inc stdio.inc iterat.inc
fitl.obj  	: fitl.f $(NLSI) $(FITI) rndoff.inc timer.inc
fixc.obj	: fixc.f nlsdim.inc eprprm.inc prmeqv.inc parcom.inc lpnam.inc stdio.inc
ftfuns.obj	: ftfuns.f
fzs.obj		: fzs.f eprprm.inc
gconvl.obj	: gconvl.f nlsdim.inc eprprm.inc ftwork.inc pidef.inc
getids.obj	: getids.f nlsdim.inc stdio.inc nlsnam.inc
getdat.obj	: getdat.f nlsdim.inc stdio.inc
helpc.obj		: helpc.f stdio.inc
ipfind.obj	: ipfind.f $(BASI) eprprm.inc parcom.inc lpnam.inc
lbasis.obj	: lbasis.f nlsdim.inc eprprm.inc mtsdef.inc stdio.inc
lbasix.obj	: lbasix.f nlsdim.inc eprprm.inc mtsdef.inc stdio.inc
lcheck.obj	: lcheck.f $(CHKI) prmeqv.inc
letc.obj	: $(LETI) stdio.inc
lfun.obj	: lfun.f $(FUNI) $(FNI2) 
lgrint.obj	: lgrint.f
lmnls.obj	: lmnls.f iterat.inc
l1pfun.obj	: l1pfun.f nlsdim.inc expdat.inc parcom.inc
matrll.obj	: matrll.f $(MATI) maxl.inc physcn.inc
mimic.obj	: mimic.f
mnbrak.obj	: mnbrak.f errmsg.inc
momdls.obj	: momdls.f $(MATI) pidef.inc stdio.inc dfunc.inc
nlsl.obj	: nlsl.f $(NLSI) $(SRLSI) parcom.inc tridag.inc basis.inc iterat.inc
nlstxt.obj	: nlstxt.f nlsdim.inc eprprm.inc lpnam.inc errmsg.inc
ordrpr.obj	: ordrpr.f rndoff.inc dfunc.inc pidef.inc
parc.obj	: parc.f nlsdim.inc eprprm.inc expdat.inc parcom.inc lpnam.inc stdio.inc rndoff.inc symdef.inc mtsdef.inc
pltx.obj	: pltx.c 
# pltd.obj	: pltd.c
pmatrl.obj	: pmatrl.f $(MATI) maxl.inc physcn.inc
pstvec.obj 	: pstvec.f nlsdim.inc eprprm.inc errmsg.inc rndoff.inc
rdpar.obj	: rdpar.f eprprm.inc stdio.inc
rms.obj		: rms.f nlsdim.inc mspctr.inc parcom.inc rndoff.inc
scalec.obj	: scalec.f $(SCLI) stdio.inc
scmvm.obj 	: scmvm.f nlsdim.inc rndoff.inc eprmat.inc eprprm.inc stdio.inc
srls.obj	: srls.f eprprm.inc $(SRLSI)
series.obj	: series.f nlsdim.inc eprprm.inc expdat.inc mspctr.inc parcom.inc stdio.inc
setmts.obj	: setmts.f nlsdim.inc eprprm.inc maxl.inc rndoff.inc mtsdef.inc
setnm.obj	: setnm.f nlsdim.inc nlsnam.inc
setprm.obj	: setprm.f $(BASI) $(PRMI) iterat.inc stdio.inc symdef.inc
setspc.obj	: setspc.f $(SPCI) iterat.inc
shiftc.obj	: shiftc.f nlsdim.inc expdat.inc parcom.inc stdio.inc
sitec.obj	: sitec.f nlsdim.inc expdat.inc parcom.inc tridag.inc basis.inc stdio.inc
srchc.obj 	: srchc.f nlsdim.inc eprprm.inc lmcom.inc parcom.inc\
 iterat.inc errmsg.inc lpnam.inc stdio.inc expdat.inc
sscale.obj	: sscale.f nlsdim.inc
statc.obj	: statc.f $(BASI) nlsdim.inc eprprm.inc expdat.inc parcom.inc\
 lmcom.inc mtsdef.inc
stats.obj	: stats.f
strutl.obj	: strutl.f stdio.inc
stvect.obj 	: stvect.f nlsdim.inc eprprm.inc errmsg.inc rndoff.inc
tdchek.obj	: tdchek.f $(BASI) tridag.inc errmsg.inc mtsdef.inc
tdqz.obj	: tdsqz.f nlsdim.inc expdat.inc tridag.inc
varyc.obj	: varyc.f nlsdim.inc eprprm.inc prmeqv.inc parcom.inc lpnam.inc stdio.inc
writr.obj	: writr.f nlsdim.inc expdat.inc lmcom.inc parcom.inc stdio.inc\
 tridag.inc mspctr.inc iterat.inc
writec.obj	: writec.f nlsdim.inc expdat.inc parcom.inc lmcom.inc mspctr.inc stdio.inc
w3j.obj		: w3j.f maxl.inc bincom.inc stdio.inc
zaxpy.obj 	: zaxpy.f nlsdim.inc rndoff.inc
zaypx.obj 	: zaypx.f nlsdim.inc rndoff.inc
znormu.obj	: znormu.f nlsdim.inc rndoff.inc
zscsw.obj	: zscsw.f nlsdim.inc rndoff.inc
zdotu.obj	: zdotu.f nlsdim.inc rndoff.inc

#-----------------------------------------------------------------------
#		Executable files
#-----------------------------------------------------------------------

nlsl: $(NLSO) 
	$(F77) /exe:nlsl $(NLSO) $(LIBS) 
#   $(FLINK) $(FFLAGS) /exe:nlsl $(NLSO) $(LIBS) -lX11 -lc

#-----------------------------------------------------------------------
#			Default actions
#-----------------------------------------------------------------------

.c.obj   :
	cl -c $*.c

.f.obj   :
	$(F77) $(FFLAGS) $*.f

.inc.obj :
	$(F77) $(FFLAGS) $*.f
