c       VERSION 1.3  3/13/92  
c**********************************************************************
c       
c                       ==================
c                       SUBROUTINE : RDDAT
c                       ==================
c
c       This read the parameter file generated by the program lbsr
c       into the common block defined in eprdat.inc. Returns nonzero
c       ierr if there was a read error. Ierr is returned as -100 
c       if the routine did not detect the proper identification string.
c
c       Notes:
c               Care should be taken to ensure that the common 
c               block definition in the include file eprdat.inc
c               is consistent with the information read in from the
c               disk files by this routine to avoid corrupting 
c               the parameter file.
c
c       written by DJS 15-NOV-87
c       modified by DEB 13-MAR-92 to allow longer filenames
c                       22-OCT-92 to check version i.d. string
c
c       Includes:
c               stdio.inc
c               eprdat.inc
c
c       Uses:
c
c**********************************************************************
c
      subroutine rddat(prname,lth,ierr)
c
      include 'stdio.inc'
      include 'eprdat.inc'
      include 'srsdat.inc'
c
      character prname*30,prmid*8
c
      integer i,j,lth,ierr
c
c######################################################################
c
c----------------------------------------------------------------------
c     open input parameter file
c----------------------------------------------------------------------
c
      open (unit=ludisk,file=prname(:lth),access='sequential',
     #      status='old',form='unformatted',iostat=ierr)
      if (ierr.eq.0) then
        read (ludisk,iostat=ierr) prmid,
     #  gxx,gyy,gzz,axx,ayy,azz,dr,dp,dm,
     #  d0r,d0p,drt,dpt,dmt,d0rt,d0pt,
     #	oss,osst,psi,bag,bed,
     #  b0,fieldi,fieldf,cgtol,shiftr,shifti,
     #	a0,g0,btol,
     #  a20,a22,a40,a42,
     #  b10,b20,c20,c22,c40,c42,
     #  (fgm(i),i=1,5),(fam(i),i=1,5),
     #  ((d2psi(i,j),i=1,5),j=1,5),
     #  ((d2bed(i,j),i=1,5),j=1,5),

c
     #  cmax
c
        if (prmid.ne.'EPRSR1.0') then
          ierr=-100
          return
        end if
c
        read (ludisk,iostat=ierr)
     #	in2,itype,
     #  lemx,lomx,mmx,kmx,jmx,nmx,imx,ipnmx,
     #  nfield,nstep,
     #  ndim,neltot,nelv,nelre,nelim,
     #  jdelta,kdelta,lkmdff,lkmtrc
c
      end if
c
c----------------------------------------------------------------------
c     close parameter file
c----------------------------------------------------------------------
c
      close (unit=ludisk)
c
c----------------------------------------------------------------------
c     return to caller
c----------------------------------------------------------------------
c
      return
      end














